using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using nsPersistExchg;

// Writen for Progress Exchange 2004
// Last Updated: DL 05/11/2004 a
namespace OpenClientPersist
{
	public class  MainForm: System.Windows.Forms.Form
	{
		#region Variables 	
		DataView vueTableTwo; 
		// Use the typed name for the .Net Open Client static dataset
		internal nsPersistExchg.StrongTypesNS.dsOrderDataSet dsOrders;
		internal DataTable dtOrder;
		internal DataTable dtOLine;
		// Set variable for the App Object 
		internal PersistAO appObj = null;
		// Set variable for the Proc Object 
		internal PersistentDS poObj = null;
		internal Progress.Open4GL.Proxy.Connection connObj;

		#region Variables-Work 	
		// The initial values will retrive the records from 1 to 2, if available
		internal int iMasterLow = 10; 			
		internal int iMasterHigh = 100;  
		internal int iLowRange = 20; 			
		internal int iHighRange = 25;  		
		internal int iSelectNum; 	
		// Fields used to filter/sort the secondary table
		string tableTwoFilter; 
		string tableTwoSort; 
		#endregion Variables-Work 	

		#region Variables-Messages 	
		internal string dspMsg;
		internal string dspCaption;
		internal MessageBoxButtons dspButton;
		internal DialogResult resultDlog;
		#endregion Variables-Messages 	

		#region Variables UI
		internal System.Windows.Forms.DataGrid dataGridOne;
		internal System.Windows.Forms.DataGrid dataGridTwo;
		internal System.Windows.Forms.Button buttonDone;
		internal System.ComponentModel.Container components = null;
		internal System.Windows.Forms.Label labelLowRange;
		internal System.Windows.Forms.Label labelHighRange;
		internal System.Windows.Forms.GroupBox Range;
		internal System.Windows.Forms.TextBox textBoxLowRange;
		internal System.Windows.Forms.TextBox textBoxHighRange;
		internal System.Windows.Forms.Label label1;
		internal System.Windows.Forms.Label label2;
		internal System.Windows.Forms.Label labelMasterHigh;
		internal System.Windows.Forms.TextBox textBoxMasterHigh;
		internal System.Windows.Forms.Label labelMasterLow;
		internal System.Windows.Forms.TextBox textBoxMasterLow;
		internal System.Windows.Forms.GroupBox groupBox1;
		internal System.Windows.Forms.Button buttonRefreshAppServerDS;
		internal System.Windows.Forms.Button buttonDisconnect;
		internal System.Windows.Forms.Button buttonConnect;
		internal System.Windows.Forms.StatusBar statusBarMain;
		internal System.Windows.Forms.StatusBarPanel statusBarPanelCount;
		internal System.Windows.Forms.StatusBarPanel statusBarPanelConnect;
		internal System.Windows.Forms.StatusBarPanel statusBarPanelStatus;
		internal System.Windows.Forms.Button buttonCallOC;
		#endregion Variables-UI
		#endregion Variables

		public MainForm()
		{
			InitializeComponent();
			Application.EnableVisualStyles();
			Application.DoEvents();
		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(MainForm));
			this.dataGridTwo = new System.Windows.Forms.DataGrid();
			this.dataGridOne = new System.Windows.Forms.DataGrid();
			this.buttonDone = new System.Windows.Forms.Button();
			this.labelLowRange = new System.Windows.Forms.Label();
			this.textBoxLowRange = new System.Windows.Forms.TextBox();
			this.labelHighRange = new System.Windows.Forms.Label();
			this.textBoxHighRange = new System.Windows.Forms.TextBox();
			this.Range = new System.Windows.Forms.GroupBox();
			this.buttonCallOC = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.labelMasterHigh = new System.Windows.Forms.Label();
			this.textBoxMasterHigh = new System.Windows.Forms.TextBox();
			this.labelMasterLow = new System.Windows.Forms.Label();
			this.textBoxMasterLow = new System.Windows.Forms.TextBox();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.buttonRefreshAppServerDS = new System.Windows.Forms.Button();
			this.buttonDisconnect = new System.Windows.Forms.Button();
			this.buttonConnect = new System.Windows.Forms.Button();
			this.statusBarMain = new System.Windows.Forms.StatusBar();
			this.statusBarPanelCount = new System.Windows.Forms.StatusBarPanel();
			this.statusBarPanelConnect = new System.Windows.Forms.StatusBarPanel();
			this.statusBarPanelStatus = new System.Windows.Forms.StatusBarPanel();
			((System.ComponentModel.ISupportInitialize)(this.dataGridTwo)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.dataGridOne)).BeginInit();
			this.Range.SuspendLayout();
			this.groupBox1.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.statusBarPanelCount)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.statusBarPanelConnect)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.statusBarPanelStatus)).BeginInit();
			this.SuspendLayout();
			// 
			// dataGridTwo
			// 
			this.dataGridTwo.AllowNavigation = false;
			this.dataGridTwo.CaptionBackColor = System.Drawing.Color.Blue;
			this.dataGridTwo.CaptionFont = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.dataGridTwo.CaptionForeColor = System.Drawing.SystemColors.ControlLightLight;
			this.dataGridTwo.CaptionText = "ORDER LINES";
			this.dataGridTwo.DataMember = "";
			this.dataGridTwo.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.dataGridTwo.Location = new System.Drawing.Point(8, 144);
			this.dataGridTwo.Name = "dataGridTwo";
			this.dataGridTwo.ReadOnly = true;
			this.dataGridTwo.Size = new System.Drawing.Size(600, 144);
			this.dataGridTwo.TabIndex = 26;
			this.dataGridTwo.CurrentCellChanged += new System.EventHandler(this.dataGridTwo_CurrentCellChanged);
			// 
			// dataGridOne
			// 
			this.dataGridOne.AllowNavigation = false;
			this.dataGridOne.CaptionBackColor = System.Drawing.Color.Blue;
			this.dataGridOne.CaptionFont = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.dataGridOne.CaptionForeColor = System.Drawing.SystemColors.ControlLightLight;
			this.dataGridOne.CaptionText = "ORDERS";
			this.dataGridOne.DataMember = "";
			this.dataGridOne.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.dataGridOne.Location = new System.Drawing.Point(8, 8);
			this.dataGridOne.Name = "dataGridOne";
			this.dataGridOne.ReadOnly = true;
			this.dataGridOne.Size = new System.Drawing.Size(600, 128);
			this.dataGridOne.TabIndex = 25;
			this.dataGridOne.CurrentCellChanged += new System.EventHandler(this.dataGridOne_CurrentCellChanged);
			// 
			// buttonDone
			// 
			this.buttonDone.Location = new System.Drawing.Point(512, 384);
			this.buttonDone.Name = "buttonDone";
			this.buttonDone.Size = new System.Drawing.Size(88, 23);
			this.buttonDone.TabIndex = 24;
			this.buttonDone.Text = "Done";
			this.buttonDone.Click += new System.EventHandler(this.buttonDone_Click);
			// 
			// labelLowRange
			// 
			this.labelLowRange.Location = new System.Drawing.Point(224, 312);
			this.labelLowRange.Name = "labelLowRange";
			this.labelLowRange.Size = new System.Drawing.Size(40, 23);
			this.labelLowRange.TabIndex = 30;
			this.labelLowRange.Text = "From";
			this.labelLowRange.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// textBoxLowRange
			// 
			this.textBoxLowRange.BackColor = System.Drawing.Color.White;
			this.textBoxLowRange.Location = new System.Drawing.Point(272, 312);
			this.textBoxLowRange.Name = "textBoxLowRange";
			this.textBoxLowRange.TabIndex = 31;
			this.textBoxLowRange.Text = "";
			this.textBoxLowRange.WordWrap = false;
			this.textBoxLowRange.MouseLeave += new System.EventHandler(this.textBoxLowRange_MouseLeave);
			// 
			// labelHighRange
			// 
			this.labelHighRange.Location = new System.Drawing.Point(232, 336);
			this.labelHighRange.Name = "labelHighRange";
			this.labelHighRange.Size = new System.Drawing.Size(32, 23);
			this.labelHighRange.TabIndex = 32;
			this.labelHighRange.Text = "To";
			this.labelHighRange.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// textBoxHighRange
			// 
			this.textBoxHighRange.BackColor = System.Drawing.Color.White;
			this.textBoxHighRange.Location = new System.Drawing.Point(272, 344);
			this.textBoxHighRange.Name = "textBoxHighRange";
			this.textBoxHighRange.TabIndex = 33;
			this.textBoxHighRange.Text = "";
			this.textBoxHighRange.WordWrap = false;
			this.textBoxHighRange.MouseLeave += new System.EventHandler(this.textBoxLowRange_MouseLeave);
			// 
			// Range
			// 
			this.Range.Controls.Add(this.buttonCallOC);
			this.Range.Location = new System.Drawing.Point(208, 296);
			this.Range.Name = "Range";
			this.Range.Size = new System.Drawing.Size(184, 110);
			this.Range.TabIndex = 34;
			this.Range.TabStop = false;
			this.Range.Text = "Select Sub-Range";
			// 
			// buttonCallOC
			// 
			this.buttonCallOC.Enabled = false;
			this.buttonCallOC.Location = new System.Drawing.Point(56, 80);
			this.buttonCallOC.Name = "buttonCallOC";
			this.buttonCallOC.Size = new System.Drawing.Size(112, 23);
			this.buttonCallOC.TabIndex = 36;
			this.buttonCallOC.Text = "Retrive Subset";
			this.buttonCallOC.Click += new System.EventHandler(this.buttonCallOC_Click);
			// 
			// label1
			// 
			this.label1.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(255)), ((System.Byte)(128)), ((System.Byte)(0)));
			this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.Location = new System.Drawing.Point(416, 304);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(176, 16);
			this.label1.TabIndex = 36;
			this.label1.Text = "Using static ProDataSet";
			// 
			// label2
			// 
			this.label2.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(255)), ((System.Byte)(128)), ((System.Byte)(0)));
			this.label2.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label2.Location = new System.Drawing.Point(416, 320);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(176, 16);
			this.label2.TabIndex = 37;
			this.label2.Text = "  with Persistence";
			// 
			// labelMasterHigh
			// 
			this.labelMasterHigh.Location = new System.Drawing.Point(32, 336);
			this.labelMasterHigh.Name = "labelMasterHigh";
			this.labelMasterHigh.Size = new System.Drawing.Size(32, 23);
			this.labelMasterHigh.TabIndex = 40;
			this.labelMasterHigh.Text = "To";
			this.labelMasterHigh.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// textBoxMasterHigh
			// 
			this.textBoxMasterHigh.BackColor = System.Drawing.Color.White;
			this.textBoxMasterHigh.Location = new System.Drawing.Point(72, 344);
			this.textBoxMasterHigh.Name = "textBoxMasterHigh";
			this.textBoxMasterHigh.TabIndex = 41;
			this.textBoxMasterHigh.Text = "";
			this.textBoxMasterHigh.WordWrap = false;
			this.textBoxMasterHigh.MouseLeave += new System.EventHandler(this.textBoxMasterLow_MouseLeave);
			// 
			// labelMasterLow
			// 
			this.labelMasterLow.Location = new System.Drawing.Point(24, 312);
			this.labelMasterLow.Name = "labelMasterLow";
			this.labelMasterLow.Size = new System.Drawing.Size(40, 23);
			this.labelMasterLow.TabIndex = 38;
			this.labelMasterLow.Text = "From";
			this.labelMasterLow.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// textBoxMasterLow
			// 
			this.textBoxMasterLow.BackColor = System.Drawing.Color.White;
			this.textBoxMasterLow.Location = new System.Drawing.Point(72, 312);
			this.textBoxMasterLow.Name = "textBoxMasterLow";
			this.textBoxMasterLow.TabIndex = 39;
			this.textBoxMasterLow.Text = "";
			this.textBoxMasterLow.WordWrap = false;
			this.textBoxMasterLow.MouseLeave += new System.EventHandler(this.textBoxMasterLow_MouseLeave);
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.Add(this.buttonRefreshAppServerDS);
			this.groupBox1.Location = new System.Drawing.Point(8, 296);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(184, 110);
			this.groupBox1.TabIndex = 42;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Select Master Range";
			// 
			// buttonRefreshAppServerDS
			// 
			this.buttonRefreshAppServerDS.Enabled = false;
			this.buttonRefreshAppServerDS.Location = new System.Drawing.Point(48, 80);
			this.buttonRefreshAppServerDS.Name = "buttonRefreshAppServerDS";
			this.buttonRefreshAppServerDS.Size = new System.Drawing.Size(120, 23);
			this.buttonRefreshAppServerDS.TabIndex = 36;
			this.buttonRefreshAppServerDS.Text = "Refresh Master";
			this.buttonRefreshAppServerDS.Click += new System.EventHandler(this.buttonRefreshAppServerDS_Click);
			// 
			// buttonDisconnect
			// 
			this.buttonDisconnect.Enabled = false;
			this.buttonDisconnect.Location = new System.Drawing.Point(408, 384);
			this.buttonDisconnect.Name = "buttonDisconnect";
			this.buttonDisconnect.Size = new System.Drawing.Size(88, 23);
			this.buttonDisconnect.TabIndex = 44;
			this.buttonDisconnect.Text = "Disconnect";
			this.buttonDisconnect.Click += new System.EventHandler(this.buttonDisconnect_Click);
			// 
			// buttonConnect
			// 
			this.buttonConnect.Location = new System.Drawing.Point(408, 352);
			this.buttonConnect.Name = "buttonConnect";
			this.buttonConnect.Size = new System.Drawing.Size(88, 23);
			this.buttonConnect.TabIndex = 43;
			this.buttonConnect.Text = "Connect";
			this.buttonConnect.Click += new System.EventHandler(this.buttonConnect_Click);
			// 
			// statusBarMain
			// 
			this.statusBarMain.Location = new System.Drawing.Point(0, 415);
			this.statusBarMain.Name = "statusBarMain";
			this.statusBarMain.Panels.AddRange(new System.Windows.Forms.StatusBarPanel[] {
																							 this.statusBarPanelCount,
																							 this.statusBarPanelConnect,
																							 this.statusBarPanelStatus});
			this.statusBarMain.ShowPanels = true;
			this.statusBarMain.Size = new System.Drawing.Size(616, 22);
			this.statusBarMain.TabIndex = 46;
			// 
			// statusBarPanelCount
			// 
			this.statusBarPanelCount.Width = 75;
			// 
			// statusBarPanelConnect
			// 
			this.statusBarPanelConnect.Alignment = System.Windows.Forms.HorizontalAlignment.Right;
			this.statusBarPanelConnect.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Spring;
			this.statusBarPanelConnect.MinWidth = 80;
			this.statusBarPanelConnect.ToolTipText = "Connection stuff is in here";
			this.statusBarPanelConnect.Width = 501;
			// 
			// statusBarPanelStatus
			// 
			this.statusBarPanelStatus.BorderStyle = System.Windows.Forms.StatusBarPanelBorderStyle.Raised;
			this.statusBarPanelStatus.Icon = ((System.Drawing.Icon)(resources.GetObject("statusBarPanelStatus.Icon")));
			this.statusBarPanelStatus.MinWidth = 24;
			this.statusBarPanelStatus.Width = 24;
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(6, 15);
			this.ClientSize = new System.Drawing.Size(616, 437);
			this.Controls.Add(this.statusBarMain);
			this.Controls.Add(this.buttonDisconnect);
			this.Controls.Add(this.buttonConnect);
			this.Controls.Add(this.labelMasterHigh);
			this.Controls.Add(this.textBoxMasterHigh);
			this.Controls.Add(this.labelMasterLow);
			this.Controls.Add(this.textBoxMasterLow);
			this.Controls.Add(this.groupBox1);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.labelHighRange);
			this.Controls.Add(this.textBoxHighRange);
			this.Controls.Add(this.labelLowRange);
			this.Controls.Add(this.textBoxLowRange);
			this.Controls.Add(this.dataGridTwo);
			this.Controls.Add(this.dataGridOne);
			this.Controls.Add(this.buttonDone);
			this.Controls.Add(this.Range);
			this.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Name = "MainForm";
			this.Text = "Exchange 2004 - OpenEdge .NET Open Client Example";
			this.Load += new System.EventHandler(this.MainForm_Load);
			((System.ComponentModel.ISupportInitialize)(this.dataGridTwo)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.dataGridOne)).EndInit();
			this.Range.ResumeLayout(false);
			this.groupBox1.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.statusBarPanelCount)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.statusBarPanelConnect)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.statusBarPanelStatus)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		[STAThread]
		static void Main() 
		{
			Application.Run(new MainForm());
		}

		#region Events
		private void buttonConnect_Click(object sender, System.EventArgs e)
		{
			ConnOpenClient(); 
		}

		private void buttonDisconnect_Click(object sender, System.EventArgs e)
		{
			disconnectOpenClient();
		}

		private void buttonDone_Click(object sender, System.EventArgs e)
		{
			disconnectOpenClient();
			Dispose(true);		
		}

		private void buttonRefreshAppServerDS_Click(object sender, System.EventArgs e)
		{
			refreshMasterDataSet(); 
		}

		private void buttonCallOC_Click(object sender, System.EventArgs e)
		{
			getRecords();
		}

		private void MainForm_Load(object sender, System.EventArgs e)
		{			
			// Initial settings for the program
			textBoxLowRange.Text = iLowRange.ToString();
			textBoxHighRange.Text = iHighRange.ToString();		
			textBoxMasterLow.Text = iMasterLow.ToString();
			textBoxMasterHigh.Text = iMasterHigh.ToString();
			tableTwoFilter = "OrderNum"; 
			tableTwoSort = "LineNum"; 
			dataGridOne.ReadOnly = true;
			dataGridTwo.ReadOnly = true;
		}
		
		private void dataGridOne_CurrentCellChanged(object sender, System.EventArgs e)
		{
			// Set the selected number to the selected row
			setCurrSelectedNum();
			vueTableTwo = new DataView(dtOLine);
			vueTableTwo.RowFilter = tableTwoFilter + " = " + iSelectNum;
			vueTableTwo.Sort = tableTwoSort;
			dataGridTwo.DataSource = vueTableTwo;

			selectGridOneRow(dataGridOne.CurrentRowIndex);
			selectGridTwoRow(0);
		}

		private void dataGridTwo_CurrentCellChanged(object sender, System.EventArgs e)
		{
			selectGridTwoRow(dataGridTwo.CurrentRowIndex);
		}

		// Make sure that upper range is always greater than or equal to the 
		//   lower range, and that lower range is greater than 1 for Master range
		private void textBoxMasterLow_MouseLeave(object sender, System.EventArgs e)
		{
			int iLowR = 1;
			int iHighR = 0;

			try
			{
				if (textBoxMasterHigh.Text != "")
					iLowR = int.Parse(textBoxMasterLow.Text);
				if (iLowR < 1)
				{
					iLowR = 1;
					textBoxMasterLow.Text = "1";
				}

				if (textBoxMasterHigh.Text != "")
					iHighR = int.Parse(textBoxMasterHigh.Text);

				if ( iLowR > iHighR )
				{ 
					textBoxMasterHigh.Text = textBoxMasterLow.Text;
				}
			}
			catch (System.Exception ex)
			{
				dspMsg ="The following exception occured: \n\r" + ex.Message;
				dspCaption = "Selection Failed";
				dspButton = MessageBoxButtons.OK;
				resultDlog = MessageBox.Show(this, dspMsg, dspCaption, dspButton,
					MessageBoxIcon.Error,
					MessageBoxDefaultButton.Button1,
					MessageBoxOptions.RightAlign);
			}		
		}

		// Make sure that upper range is always greater than or equal to the 
		//   lower range, and that lower range is greater than 1 for sub-range
		private void textBoxLowRange_MouseLeave(object sender, System.EventArgs e)
		{
			int iLowR = 1;
			int iHighR = 0;

			try
			{
				if (textBoxHighRange.Text != "")
					iLowR = int.Parse(textBoxLowRange.Text);
				if (iLowR < 1)
				{
					iLowR = 1;
					textBoxLowRange.Text = "1";
				}

				if (textBoxHighRange.Text != "")
					iHighR = int.Parse(textBoxHighRange.Text);

				if ( iLowR > iHighR )
				{ 
					textBoxHighRange.Text = textBoxLowRange.Text;
				}
			}
			catch (System.Exception ex)
			{
				dspMsg ="The following exception occured: \n\r" + ex.Message;
				dspCaption = "Selection Failed";
				dspButton = MessageBoxButtons.OK;
				resultDlog = MessageBox.Show(this, dspMsg, dspCaption, dspButton,
					MessageBoxIcon.Error,
					MessageBoxDefaultButton.Button1,
					MessageBoxOptions.RightAlign);
			}		
		}
		#endregion Events

		#region Methods-Call-OpenClient
		// Call the AppServer to update the records in the persistent ProDataSet
		public void refreshMasterDataSet()
		{		
			iMasterLow = int.Parse(textBoxMasterLow.Text);
			iMasterHigh = int.Parse(textBoxMasterHigh.Text);
			
			try
			{
				poObj.fillMaster(iMasterLow, iMasterHigh);
			}		
			catch (Progress.Open4GL.Exceptions.Open4GLException ex)
			{
				dspMsg = ex.Message;
				dspCaption = "Open 4GL Exception";
				dspButton = MessageBoxButtons.OK;
				resultDlog = MessageBox.Show(this, dspMsg, dspCaption, dspButton,
					MessageBoxIcon.Information,
					MessageBoxDefaultButton.Button1,
					MessageBoxOptions.RightAlign);
			}
		}

		// Return a subset of records from the ProDataSet and display in 
		//  DataGrids
		public void getRecords()
		{
			iLowRange = int.Parse(textBoxLowRange.Text);
			iHighRange = int.Parse(textBoxHighRange.Text);
			try
			{			
				iSelectNum = iLowRange; 

				// Call AppServer to get the data 
				try
				{
					poObj.returnSubset(iLowRange, iHighRange, out dsOrders);
				}	
				catch (Progress.Open4GL.Exceptions.Open4GLException ex)
				{
					dspMsg = ex.Message;
					dspCaption = "Open 4GL Exception";
					dspButton = MessageBoxButtons.OK;
					resultDlog = MessageBox.Show(this, dspMsg, dspCaption, dspButton,
						MessageBoxIcon.Information,
						MessageBoxDefaultButton.Button1,
						MessageBoxOptions.RightAlign);
				}

				dtOrder = dsOrders.Tables[0];  
				dtOLine = dsOrders.Tables[1]; 

				dataGridOne.SetDataBinding(dsOrders, dsOrders.Tables[0].TableName);
				
				// Set the selected number to the first available selection number in the range
				if (dtOrder.Rows.Count > 0)
				{
					iSelectNum  = int.Parse((dtOrder.Rows[0].ItemArray[0].ToString()));
				}

				vueTableTwo = new DataView(dtOLine);
				vueTableTwo.RowFilter = tableTwoFilter + " = " + iSelectNum;
				vueTableTwo.Sort = tableTwoSort;
				dataGridTwo.DataSource = vueTableTwo;

				// Check to see if any rows were found before selecting a row ...
				if (dtOrder.Rows.Count != 0) 
				{
					selectGridOneRow(0);
					if (dtOLine.Rows.Count != 0) 
						selectGridTwoRow(0);
				}
				else
				{
					// Information message
					dspMsg ="No rows match the selected range.";
					dspCaption = "No data found matching selection";
					dspButton = MessageBoxButtons.OK;
					resultDlog = MessageBox.Show(this, dspMsg, dspCaption, dspButton,
						MessageBoxIcon.Information,
						MessageBoxDefaultButton.Button1,
						MessageBoxOptions.RightAlign);
				}	
			}
			catch (System.Exception ex)
			{
				dspMsg ="The following exception occured: \n\r" + ex.Message;
				dspCaption = "Error in method getRecords";
				dspButton = MessageBoxButtons.OK;
				resultDlog = MessageBox.Show(this, dspMsg, dspCaption, dspButton,
					MessageBoxIcon.Information,
					MessageBoxDefaultButton.Button1,
					MessageBoxOptions.RightAlign);
			}
		}
		#endregion Methods-Call-OpenClient

		#region Methods-RowSelection
		public void setCurrSelectedNum()
		{ 
			DataGridCell tableOneCell = new DataGridCell();
			tableOneCell.RowNumber = dataGridOne.CurrentRowIndex;
			tableOneCell.ColumnNumber = 0;
			iSelectNum = int.Parse(dataGridOne[tableOneCell].ToString());
			return; 
		}

		public void setCurrTableTwoNum()
		{ 
			DataGridCell tableTwoCell = new DataGridCell();
			tableTwoCell.RowNumber = dataGridTwo.CurrentRowIndex;
			tableTwoCell.ColumnNumber = 0;
			return; 
		}

		// Select the row (highlight) - unselect previous row
		public void selectGridOneRow(int selRowNum)
		{
			dataGridOne.Select(selRowNum); 
			dataGridOne.CurrentRowIndex = selRowNum;
			return; 
		}

		// Select the row (highlight) - unselect previous row
		public void selectGridTwoRow(int selRowNum)
		{
			try
			{
				try
				{
					// Unselect last selected row
					dataGridTwo.Select(selRowNum); 
				}
				catch (System.Exception ex)
				{
					dspMsg ="The following exception occured: \n\r" + ex.Message;
					dspCaption = "Selection Failed";
					dspButton = MessageBoxButtons.OK;
					resultDlog = MessageBox.Show(this, dspMsg, dspCaption, dspButton,
						MessageBoxIcon.Error,
						MessageBoxDefaultButton.Button1,
						MessageBoxOptions.RightAlign);
				}

				// Position view port for new row
				dataGridTwo.CurrentRowIndex = selRowNum;
				// Remember this row for unselect
				setCurrTableTwoNum(); 
			}
			catch (System.Exception ex)
			{
				dspMsg ="The following exception occured: \n\r" + ex.Message;
				dspCaption = "Selection Failed";
				dspButton = MessageBoxButtons.OK;
				resultDlog = MessageBox.Show(this, dspMsg, dspCaption, dspButton,
					MessageBoxIcon.Error,
					MessageBoxDefaultButton.Button1,
					MessageBoxOptions.RightAlign);
			}
			return; 
		}
		#endregion Methods-RowSelection

		#region Methods-Connection
		public void ConnOpenClient()
		{
			// Connect to the AppServer using the EstablishConnection class
			EstablishConnection estConnection = new EstablishConnection(this.appObj);
			estConnection.ShowDialog(); 
			this.appObj = estConnection.getAppObj(out connObj);	
			if (appObj != null)
			{
				try
				{
					poObj = appObj.CreatePO_PersistentDS(); 
				}			
				catch (Progress.Open4GL.Exceptions.Open4GLException ex)
				{
					dspMsg = ex.Message;
					dspCaption = "Open 4GL Exception";
					dspButton = MessageBoxButtons.OK;
					resultDlog = MessageBox.Show(this, dspMsg, dspCaption, dspButton,
						MessageBoxIcon.Information,
						MessageBoxDefaultButton.Button1,
						MessageBoxOptions.RightAlign);
				}
				catch (System.Exception ex)
				{
					dspMsg = "Error: Couldn't connect to procedure object. " + ex;
					dspCaption = "Create Connection to ProcObject";
					dspButton = MessageBoxButtons.OK;
					resultDlog = MessageBox.Show(this, dspMsg, dspCaption, dspButton,
						MessageBoxIcon.Error,
						MessageBoxDefaultButton.Button1,
						MessageBoxOptions.RightAlign);						
				}

				if (poObj != null)
				{
					statusBarPanelConnect.Text = "Connected: " + connObj.Url;		
					statusBarPanelStatus.Icon = Utility.stopngo.Go();
					buttonConnect.Enabled = false; 
					buttonDisconnect.Enabled = true; 
					buttonCallOC.Enabled = true;
					buttonRefreshAppServerDS.Enabled = true; 

					refreshMasterDataSet(); 
					getRecords();
				}
			}
		}

		public void disconnectOpenClient()
		{
			if (appObj != null)
			{
				try
				{
					try
					{
						if (poObj != null)
						{
							// Call .NET Open Client proxy to disconnect App Object
							poObj.Dispose();					
							poObj = null; 
						}
					}			
					catch (Progress.Open4GL.Exceptions.Open4GLException ex)
					{
						dspMsg = ex.Message;
						dspCaption = "Open 4GL Exception";
						dspButton = MessageBoxButtons.OK;
						resultDlog = MessageBox.Show(this, dspMsg, dspCaption, dspButton,
							MessageBoxIcon.Information,
							MessageBoxDefaultButton.Button1,
							MessageBoxOptions.RightAlign);
					}
					catch (System.Exception ex)
					{
						dspMsg = "Error: Couldn't release connection." + ex;
						dspCaption = "Error on release of PO connection";
						dspButton = MessageBoxButtons.OK;
						resultDlog = MessageBox.Show(this, dspMsg, dspCaption, dspButton, 
							MessageBoxIcon.Error,
							MessageBoxDefaultButton.Button1,
							MessageBoxOptions.RightAlign);
					}
				}
				finally
				{
					try
					{
						// Call .NET Open Client proxy to disconnect App Object 
						if (appObj != null)
						{
							appObj.Dispose();
							appObj = null; 
							statusBarPanelConnect.Text = "Not Connected ";
							statusBarPanelStatus.Icon = Utility.stopngo.Stop();
						}
					}			
					catch (Progress.Open4GL.Exceptions.Open4GLException ex)
					{
						dspMsg = ex.Message;
						dspCaption = "Open 4GL Exception";
						dspButton = MessageBoxButtons.OK;
						resultDlog = MessageBox.Show(this, dspMsg, dspCaption, dspButton,
							MessageBoxIcon.Information,
							MessageBoxDefaultButton.Button1,
							MessageBoxOptions.RightAlign);
					}
					catch (System.Exception ex)
					{
						dspMsg = "Error: Couldn't release connection." + ex;
						dspCaption = "Error on release of connection";
						dspButton = MessageBoxButtons.OK;
						resultDlog = MessageBox.Show(this, dspMsg, dspCaption, dspButton, 
							MessageBoxIcon.Error,
							MessageBoxDefaultButton.Button1,
							MessageBoxOptions.RightAlign);
					}
				}				
			}
			// Enable connect button to allow reconnect
			buttonConnect.Enabled = true; 
			buttonDisconnect.Enabled = false; 
			buttonCallOC.Enabled = false; 
			buttonRefreshAppServerDS.Enabled = false; 
			return;
		}
		#endregion Methods-Connection
	}
}
