using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using nsUpdateExchg; 

// Writen for Progress Exchange 2004
// Last Updated: DL 05/11/2004 a
namespace OpenClientUpdate
{
	public class  MainForm: System.Windows.Forms.Form
	{
		#region Variables 	
		#region Variables-Data 					
		DataView vueTableTwo; 
		// Use the strong typed name for the .Net Open Client static dataset
		internal nsUpdateExchg.StrongTypesNS.dsOrderDataSet dsOrders;
		internal DataTable dtTableOne;
		internal DataTable dtTableTwo;
		// Set variable for the App Object 
		internal UpdateAO appObj = null;
		internal Progress.Open4GL.Proxy.Connection connObj;
		#endregion Variables-Data 

		#region Variables-Work 			
		// bInitConn is used to do some setup the first time a connection is made
		internal bool bInitConn = true; 
		internal bool bIgnoreChgs = false; 
		internal bool bMergeField = true; 
		// The initial values will retrive the records from 1 to 2, if available
		internal int iLowRange = 1; 			
		internal int iHighRange = 2; 
		internal int iSelectNum; 		
		// Fields used to filter/sort the secondary table
		internal string tableTwoFilter; 
		internal string tableTwoSort; 
		#endregion Variables-Work 	

		#region Variables-Column 
		// These variables keep track of column level information between event calls
		internal bool enteredQtyColumn = false;
		internal bool enteredDiscountColumn = false;
		internal int  enteredRowSave = -1; 
		internal int  originalQty = -1;
		internal int  originalDiscount = -1;
		#endregion Variables-Column 	

		#region Variables-Messages 	
		internal string dspMsg;
		internal string dspCaption;
		internal MessageBoxButtons dspButton;
		internal DialogResult resultDlog;
		#endregion Variables-Messages 	

		#region Variables UI
		internal System.Windows.Forms.DataGrid dataGridOne;
		internal System.Windows.Forms.DataGrid dataGridTwo;
		internal System.Windows.Forms.Button buttonDone;
		internal System.ComponentModel.Container components = null;
		internal System.Windows.Forms.Label labelLowRange;
		internal System.Windows.Forms.Label labelHighRange;
		internal System.Windows.Forms.GroupBox Range;
		internal System.Windows.Forms.TextBox textBoxLowRange;
		internal System.Windows.Forms.TextBox textBoxHighRange;
		internal System.Windows.Forms.Label label1;
		internal System.Windows.Forms.Button buttonConnect;
		internal System.Windows.Forms.Button buttonDisconnect;
		internal System.Windows.Forms.Button buttonCancel;
		internal System.Windows.Forms.Button buttonSave;
		internal System.Windows.Forms.Button buttonDelete;
		internal System.Windows.Forms.Button buttonAdd;
		internal System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.CheckBox checkBoxIgnorConflict;
		private System.Windows.Forms.CheckBox checkBoxMrgFld;
		internal System.Windows.Forms.StatusBar statusBarMain;
		internal System.Windows.Forms.StatusBarPanel statusBarPanelCount;
		internal System.Windows.Forms.StatusBarPanel statusBarPanelConnect;
		internal System.Windows.Forms.StatusBarPanel statusBarPanelStatus;
		internal System.Windows.Forms.Button buttonCallOC;
		#endregion Variables-UI
		#endregion Variables

		public MainForm()
		{
			InitializeComponent();
			Application.EnableVisualStyles();
			Application.DoEvents();
		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(MainForm));
			this.dataGridTwo = new System.Windows.Forms.DataGrid();
			this.dataGridOne = new System.Windows.Forms.DataGrid();
			this.buttonDone = new System.Windows.Forms.Button();
			this.labelLowRange = new System.Windows.Forms.Label();
			this.textBoxLowRange = new System.Windows.Forms.TextBox();
			this.labelHighRange = new System.Windows.Forms.Label();
			this.textBoxHighRange = new System.Windows.Forms.TextBox();
			this.Range = new System.Windows.Forms.GroupBox();
			this.buttonCallOC = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this.buttonConnect = new System.Windows.Forms.Button();
			this.buttonDisconnect = new System.Windows.Forms.Button();
			this.buttonCancel = new System.Windows.Forms.Button();
			this.buttonSave = new System.Windows.Forms.Button();
			this.buttonDelete = new System.Windows.Forms.Button();
			this.buttonAdd = new System.Windows.Forms.Button();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.checkBoxMrgFld = new System.Windows.Forms.CheckBox();
			this.checkBoxIgnorConflict = new System.Windows.Forms.CheckBox();
			this.statusBarMain = new System.Windows.Forms.StatusBar();
			this.statusBarPanelCount = new System.Windows.Forms.StatusBarPanel();
			this.statusBarPanelConnect = new System.Windows.Forms.StatusBarPanel();
			this.statusBarPanelStatus = new System.Windows.Forms.StatusBarPanel();
			((System.ComponentModel.ISupportInitialize)(this.dataGridTwo)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.dataGridOne)).BeginInit();
			this.Range.SuspendLayout();
			this.groupBox1.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.statusBarPanelCount)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.statusBarPanelConnect)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.statusBarPanelStatus)).BeginInit();
			this.SuspendLayout();
			// 
			// dataGridTwo
			// 
			this.dataGridTwo.AllowNavigation = false;
			this.dataGridTwo.CaptionVisible = false;
			this.dataGridTwo.DataMember = "";
			this.dataGridTwo.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.dataGridTwo.Location = new System.Drawing.Point(8, 144);
			this.dataGridTwo.Name = "dataGridTwo";
			this.dataGridTwo.Size = new System.Drawing.Size(600, 128);
			this.dataGridTwo.TabIndex = 26;
			this.dataGridTwo.CurrentCellChanged += new System.EventHandler(this.dataGridTwo_CurrentCellChanged);
			this.dataGridTwo.Leave += new System.EventHandler(this.dataGridTwo_Leave);
			// 
			// dataGridOne
			// 
			this.dataGridOne.AllowNavigation = false;
			this.dataGridOne.CaptionVisible = false;
			this.dataGridOne.DataMember = "";
			this.dataGridOne.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.dataGridOne.Location = new System.Drawing.Point(8, 8);
			this.dataGridOne.Name = "dataGridOne";
			this.dataGridOne.ReadOnly = true;
			this.dataGridOne.Size = new System.Drawing.Size(600, 128);
			this.dataGridOne.TabIndex = 25;
			this.dataGridOne.CurrentCellChanged += new System.EventHandler(this.dataGridOne_CurrentCellChanged);
			// 
			// buttonDone
			// 
			this.buttonDone.Location = new System.Drawing.Point(520, 368);
			this.buttonDone.Name = "buttonDone";
			this.buttonDone.Size = new System.Drawing.Size(88, 23);
			this.buttonDone.TabIndex = 24;
			this.buttonDone.Text = "Done";
			this.buttonDone.Click += new System.EventHandler(this.buttonDone_Click);
			// 
			// labelLowRange
			// 
			this.labelLowRange.Location = new System.Drawing.Point(8, 24);
			this.labelLowRange.Name = "labelLowRange";
			this.labelLowRange.Size = new System.Drawing.Size(40, 23);
			this.labelLowRange.TabIndex = 30;
			this.labelLowRange.Text = "From";
			this.labelLowRange.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// textBoxLowRange
			// 
			this.textBoxLowRange.BackColor = System.Drawing.Color.White;
			this.textBoxLowRange.Location = new System.Drawing.Point(56, 24);
			this.textBoxLowRange.Name = "textBoxLowRange";
			this.textBoxLowRange.TabIndex = 31;
			this.textBoxLowRange.Text = "";
			this.textBoxLowRange.WordWrap = false;
			this.textBoxLowRange.MouseLeave += new System.EventHandler(this.textBoxLowRange_MouseLeave);
			// 
			// labelHighRange
			// 
			this.labelHighRange.Location = new System.Drawing.Point(16, 56);
			this.labelHighRange.Name = "labelHighRange";
			this.labelHighRange.Size = new System.Drawing.Size(32, 23);
			this.labelHighRange.TabIndex = 32;
			this.labelHighRange.Text = "To";
			this.labelHighRange.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// textBoxHighRange
			// 
			this.textBoxHighRange.BackColor = System.Drawing.Color.White;
			this.textBoxHighRange.Location = new System.Drawing.Point(56, 56);
			this.textBoxHighRange.Name = "textBoxHighRange";
			this.textBoxHighRange.TabIndex = 33;
			this.textBoxHighRange.Text = "";
			this.textBoxHighRange.WordWrap = false;
			this.textBoxHighRange.MouseLeave += new System.EventHandler(this.textBoxLowRange_MouseLeave);
			// 
			// Range
			// 
			this.Range.Controls.Add(this.textBoxHighRange);
			this.Range.Controls.Add(this.labelLowRange);
			this.Range.Controls.Add(this.textBoxLowRange);
			this.Range.Controls.Add(this.labelHighRange);
			this.Range.Controls.Add(this.buttonCallOC);
			this.Range.Location = new System.Drawing.Point(248, 280);
			this.Range.Name = "Range";
			this.Range.Size = new System.Drawing.Size(168, 117);
			this.Range.TabIndex = 34;
			this.Range.TabStop = false;
			this.Range.Text = "Select Range";
			// 
			// buttonCallOC
			// 
			this.buttonCallOC.Enabled = false;
			this.buttonCallOC.Location = new System.Drawing.Point(72, 88);
			this.buttonCallOC.Name = "buttonCallOC";
			this.buttonCallOC.Size = new System.Drawing.Size(88, 23);
			this.buttonCallOC.TabIndex = 35;
			this.buttonCallOC.Text = "Refresh";
			this.buttonCallOC.Click += new System.EventHandler(this.buttonCallOC_Click);
			// 
			// label1
			// 
			this.label1.BackColor = System.Drawing.Color.Yellow;
			this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.Location = new System.Drawing.Point(424, 288);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(176, 16);
			this.label1.TabIndex = 36;
			this.label1.Text = "Update Progress Database";
			// 
			// buttonConnect
			// 
			this.buttonConnect.Location = new System.Drawing.Point(424, 336);
			this.buttonConnect.Name = "buttonConnect";
			this.buttonConnect.Size = new System.Drawing.Size(88, 23);
			this.buttonConnect.TabIndex = 37;
			this.buttonConnect.Text = "Connect";
			this.buttonConnect.Click += new System.EventHandler(this.buttonConnect_Click);
			// 
			// buttonDisconnect
			// 
			this.buttonDisconnect.Enabled = false;
			this.buttonDisconnect.Location = new System.Drawing.Point(424, 368);
			this.buttonDisconnect.Name = "buttonDisconnect";
			this.buttonDisconnect.Size = new System.Drawing.Size(88, 23);
			this.buttonDisconnect.TabIndex = 38;
			this.buttonDisconnect.Text = "Disconnect";
			this.buttonDisconnect.Click += new System.EventHandler(this.buttonDisconnect_Click);
			// 
			// buttonCancel
			// 
			this.buttonCancel.Enabled = false;
			this.buttonCancel.Location = new System.Drawing.Point(8, 88);
			this.buttonCancel.Name = "buttonCancel";
			this.buttonCancel.TabIndex = 42;
			this.buttonCancel.Text = "Cancel";
			this.buttonCancel.Click += new System.EventHandler(this.buttonCancel_Click);
			// 
			// buttonSave
			// 
			this.buttonSave.Enabled = false;
			this.buttonSave.Location = new System.Drawing.Point(8, 56);
			this.buttonSave.Name = "buttonSave";
			this.buttonSave.TabIndex = 41;
			this.buttonSave.Text = "Save";
			this.buttonSave.Click += new System.EventHandler(this.buttonSave_Click);
			// 
			// buttonDelete
			// 
			this.buttonDelete.Enabled = false;
			this.buttonDelete.Location = new System.Drawing.Point(96, 24);
			this.buttonDelete.Name = "buttonDelete";
			this.buttonDelete.TabIndex = 40;
			this.buttonDelete.Text = "Delete";
			this.buttonDelete.Click += new System.EventHandler(this.buttonDelete_Click);
			// 
			// buttonAdd
			// 
			this.buttonAdd.Enabled = false;
			this.buttonAdd.Location = new System.Drawing.Point(16, 304);
			this.buttonAdd.Name = "buttonAdd";
			this.buttonAdd.TabIndex = 39;
			this.buttonAdd.Text = "Add";
			this.buttonAdd.Click += new System.EventHandler(this.buttonAdd_Click);
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.Add(this.checkBoxMrgFld);
			this.groupBox1.Controls.Add(this.checkBoxIgnorConflict);
			this.groupBox1.Controls.Add(this.buttonSave);
			this.groupBox1.Controls.Add(this.buttonDelete);
			this.groupBox1.Controls.Add(this.buttonCancel);
			this.groupBox1.Location = new System.Drawing.Point(8, 280);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(232, 117);
			this.groupBox1.TabIndex = 43;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Modifications";
			// 
			// checkBoxMrgFld
			// 
			this.checkBoxMrgFld.Checked = true;
			this.checkBoxMrgFld.CheckState = System.Windows.Forms.CheckState.Checked;
			this.checkBoxMrgFld.Location = new System.Drawing.Point(96, 88);
			this.checkBoxMrgFld.Name = "checkBoxMrgFld";
			this.checkBoxMrgFld.Size = new System.Drawing.Size(128, 24);
			this.checkBoxMrgFld.TabIndex = 46;
			this.checkBoxMrgFld.Text = "Merge Field";
			this.checkBoxMrgFld.CheckedChanged += new System.EventHandler(this.checkBoxMrgFld_CheckedChanged);
			// 
			// checkBoxIgnorConflict
			// 
			this.checkBoxIgnorConflict.Location = new System.Drawing.Point(96, 56);
			this.checkBoxIgnorConflict.Name = "checkBoxIgnorConflict";
			this.checkBoxIgnorConflict.Size = new System.Drawing.Size(128, 24);
			this.checkBoxIgnorConflict.TabIndex = 45;
			this.checkBoxIgnorConflict.Text = "Ignore Modified";
			this.checkBoxIgnorConflict.CheckedChanged += new System.EventHandler(this.checkBoxIgnorConflict_CheckedChanged);
			// 
			// statusBarMain
			// 
			this.statusBarMain.Location = new System.Drawing.Point(0, 399);
			this.statusBarMain.Name = "statusBarMain";
			this.statusBarMain.Panels.AddRange(new System.Windows.Forms.StatusBarPanel[] {
																							 this.statusBarPanelCount,
																							 this.statusBarPanelConnect,
																							 this.statusBarPanelStatus});
			this.statusBarMain.ShowPanels = true;
			this.statusBarMain.Size = new System.Drawing.Size(616, 22);
			this.statusBarMain.TabIndex = 47;
			// 
			// statusBarPanelCount
			// 
			this.statusBarPanelCount.Width = 75;
			// 
			// statusBarPanelConnect
			// 
			this.statusBarPanelConnect.Alignment = System.Windows.Forms.HorizontalAlignment.Right;
			this.statusBarPanelConnect.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Spring;
			this.statusBarPanelConnect.MinWidth = 80;
			this.statusBarPanelConnect.ToolTipText = "Connection stuff is in here";
			this.statusBarPanelConnect.Width = 501;
			// 
			// statusBarPanelStatus
			// 
			this.statusBarPanelStatus.BorderStyle = System.Windows.Forms.StatusBarPanelBorderStyle.Raised;
			this.statusBarPanelStatus.Icon = ((System.Drawing.Icon)(resources.GetObject("statusBarPanelStatus.Icon")));
			this.statusBarPanelStatus.MinWidth = 24;
			this.statusBarPanelStatus.Width = 24;
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(6, 15);
			this.ClientSize = new System.Drawing.Size(616, 421);
			this.Controls.Add(this.statusBarMain);
			this.Controls.Add(this.buttonAdd);
			this.Controls.Add(this.buttonDisconnect);
			this.Controls.Add(this.buttonConnect);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.dataGridTwo);
			this.Controls.Add(this.dataGridOne);
			this.Controls.Add(this.buttonDone);
			this.Controls.Add(this.Range);
			this.Controls.Add(this.groupBox1);
			this.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Name = "MainForm";
			this.Text = "Exchange 2004 - OpenEdge .NET Open Client Example";
			this.Load += new System.EventHandler(this.MainForm_Load);
			((System.ComponentModel.ISupportInitialize)(this.dataGridTwo)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.dataGridOne)).EndInit();
			this.Range.ResumeLayout(false);
			this.groupBox1.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.statusBarPanelCount)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.statusBarPanelConnect)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.statusBarPanelStatus)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		[STAThread]
		static void Main() 
		{
			Application.Run(new MainForm());
		}

		#region Events
		private void buttonConnect_Click(object sender, System.EventArgs e)
		{
			// Connect to the AppServer using the EstablishConnection class
			EstablishConnection estConnection = new EstablishConnection(this.appObj);
			estConnection.ShowDialog(); 
			this.appObj = estConnection.getAppObj(out connObj);			
			if (appObj != null)
			{
				statusBarPanelConnect.Text = "Connected: " + connObj.Url;		
				statusBarPanelStatus.Icon = Utility.stopngo.Go();	
				buttonConnect.Enabled = false; 
				buttonDisconnect.Enabled = true; 
				buttonCallOC.Enabled = true;
				modeAvailOrderRecord(); 
				getRecords();
			}
		}

		private void buttonDisconnect_Click(object sender, System.EventArgs e)
		{
			disconnectOpenClient();
		}

		private void buttonDone_Click(object sender, System.EventArgs e)
		{
			bool confirmExit = true;

			// Alert user that changes will be lost
			if (buttonSave.Enabled == true)
			{
				dspMsg = "Do you want to return to save pending changes?";
				dspCaption = "Changes have not been saved";
				dspButton = MessageBoxButtons.YesNo;
				resultDlog = MessageBox.Show(this, dspMsg, dspCaption, dspButton,
					MessageBoxIcon.Question,
					MessageBoxDefaultButton.Button1,
					MessageBoxOptions.RightAlign);

				if(resultDlog == DialogResult.Yes)
				{
					confirmExit = false;
				}
			}

			if (confirmExit == true)
			{
				disconnectOpenClient();
				Dispose(true);
			}
		}

		private void buttonCallOC_Click(object sender, System.EventArgs e)
		{
			getRecords();
		}

		private void MainForm_Load(object sender, System.EventArgs e)
		{
			// Initial settings for the program
			textBoxLowRange.Text = iLowRange.ToString();
			textBoxHighRange.Text = iHighRange.ToString();
			tableTwoFilter = "OrderNum"; 
			tableTwoSort = "LineNum"; 
		}
		
		private void dataGridOne_CurrentCellChanged(object sender, System.EventArgs e)
		{
			// Set the selected number to the selected row
			setCurrSelectedNum();
			vueTableTwo = new DataView(dtTableTwo);
			vueTableTwo.AllowNew = false;
			vueTableTwo.RowFilter = tableTwoFilter + " = " + iSelectNum;
			vueTableTwo.Sort = tableTwoSort;
			dataGridTwo.DataSource = vueTableTwo;

			selectGridOneRow(dataGridOne.CurrentRowIndex);
			selectGridTwoRow(0);
		}

		// Make sure that upper range is always greater than or equal to the 
		//   lower range, and that lower range is greater than 1
		private void textBoxLowRange_MouseLeave(object sender, System.EventArgs e)
		{
			int iLowR = 1;
			int iHighR = 0;

			try
			{
				if (textBoxHighRange.Text != "")
					iLowR = int.Parse(textBoxLowRange.Text);
				if (iLowR < 1)
				{
					iLowR = 1;
					textBoxLowRange.Text = "1";
				}

				if (textBoxHighRange.Text != "")
					iHighR = int.Parse(textBoxHighRange.Text);

				if ( iLowR > iHighR )
				{ 
					textBoxHighRange.Text = textBoxLowRange.Text;
				}
			}
			catch (System.Exception ex)
			{
				dspMsg ="The following exception occured: \n\r" + ex.Message;
				dspCaption = "Error on mouse leave";
				dspButton = MessageBoxButtons.OK;
				resultDlog = MessageBox.Show(this, dspMsg, dspCaption, dspButton,
					MessageBoxIcon.Error,
					MessageBoxDefaultButton.Button1,
					MessageBoxOptions.RightAlign);
			}		
		}
		#endregion Events
		
		#region Event-Modifications
		private void buttonAdd_Click(object sender, System.EventArgs e)
		{
			DataRow addNewRow = dsOrders.Tables[1].NewRow();
			addRecord(addNewRow); 
		}

		private void buttonDelete_Click(object sender, System.EventArgs e)
		{
			deleteRecord(); 
		}

		private void buttonSave_Click(object sender, System.EventArgs e)
		{
			saveChanges();
		}

		private void checkBoxIgnorConflict_CheckedChanged(object sender, System.EventArgs e)
		{
			bIgnoreChgs = checkBoxIgnorConflict.Checked;
		}

		private void checkBoxMrgFld_CheckedChanged(object sender, System.EventArgs e)
		{
			bMergeField = checkBoxMrgFld.Checked;
		}

		private void buttonCancel_Click(object sender, System.EventArgs e)
		{
			cancelChanges(); 
		}

		// On leave of Order Line DataGrid 
		//    finsh up calculations if Qty or Discount changed
		private void dataGridTwo_Leave(object sender, System.EventArgs e)
		{
			// If leaving columns Qty or Discount then make updates as needed
			if ( (enteredQtyColumn == true) ||(enteredDiscountColumn == true) ) 
			{
				updateExtPrice();
			}
		}

		// On CellChanged of dataGridTwo
		//    Set the current rows for order line DataGrid
		// Save current infromation if entering Qty or Discount columns
		// Check for and process changes if leaving Qty or Discount columns
		private void dataGridTwo_CurrentCellChanged(object sender, System.EventArgs e)
		{
			// If leaving columns Qty or Discount then make updates as needed
			if ( (enteredQtyColumn == true) ||(enteredDiscountColumn == true) ) 
			{
				updateExtPrice();
			}

			// If entering columns Qty or Discount then set variables
			if (dataGridTwo.CurrentCell.ColumnNumber == 4)
			{
				enteredQtyColumn = true; 
				enteredRowSave = dataGridTwo.CurrentCell.RowNumber;
				originalQty = int.Parse(dataGridTwo[dataGridTwo.CurrentCell].ToString());
			}
			else if (dataGridTwo.CurrentCell.ColumnNumber == 5)
			{
				enteredDiscountColumn = true; 
				enteredRowSave = dataGridTwo.CurrentCell.RowNumber;
				originalDiscount = int.Parse(dataGridTwo[dataGridTwo.CurrentCell].ToString()); 
			}	

			selectGridTwoRow(dataGridTwo.CurrentRowIndex);
		}
		#endregion Event-Modifications

		#region Methods-Call-OpenClient
		public void getRecords()
		{
			iLowRange = int.Parse(textBoxLowRange.Text);
			iHighRange = int.Parse(textBoxHighRange.Text);
			try
			{			
				iSelectNum = iLowRange; 

				// Call AppServer to get the data 
				try
				{
					appObj.StaticDS(iLowRange, iHighRange, out dsOrders);
				}		
				catch (Progress.Open4GL.Exceptions.Open4GLException ex)
				{
					dspMsg = ex.Message;
					dspCaption = "Open 4GL Exception";
					dspButton = MessageBoxButtons.OK;
					resultDlog = MessageBox.Show(this, dspMsg, dspCaption, dspButton,
						MessageBoxIcon.Information,
						MessageBoxDefaultButton.Button1,
						MessageBoxOptions.RightAlign);
				}

				dtTableOne = dsOrders.Tables[0];  
				dtTableTwo = dsOrders.Tables[1]; 

				dataGridOne.SetDataBinding(dsOrders, dsOrders.Tables[0].TableName);
				
				// Set the selected number to the first available selection number in the range
				if (dtTableOne.Rows.Count > 0)
				{
					iSelectNum  = int.Parse((dtTableOne.Rows[0].ItemArray[0].ToString()));
				}

				vueTableTwo = new DataView(dtTableTwo);
				vueTableTwo.AllowNew = false;
				vueTableTwo.RowFilter = tableTwoFilter + " = " + iSelectNum;
				vueTableTwo.Sort = tableTwoSort;
				dataGridTwo.DataSource = vueTableTwo;

				if (bInitConn == true)
				{
					bInitConn = false; 
					initializeGrids(); 
				}

				// Check to see if any rows were found before selecting a row ...
				if (dtTableOne.Rows.Count != 0) 
				{
					selectGridOneRow(0);
					if (dtTableTwo.Rows.Count != 0) 
						selectGridTwoRow(0);
				}
				else
				{
					// Information message
					dspMsg ="No rows match the selected range.";
					dspCaption = "No data found matching selection";
					dspButton = MessageBoxButtons.OK;
					resultDlog = MessageBox.Show(this, dspMsg, dspCaption, dspButton,
						MessageBoxIcon.Information,
						MessageBoxDefaultButton.Button1,
						MessageBoxOptions.RightAlign);
				}	
			}
			catch (System.Exception ex)
			{
				dspMsg ="The following exception occured: \n\r" + ex.Message;
				dspCaption = "Error in method getRecords";
				dspButton = MessageBoxButtons.OK;
				resultDlog = MessageBox.Show(this, dspMsg, dspCaption, dspButton,
					MessageBoxIcon.Information,
					MessageBoxDefaultButton.Button1,
					MessageBoxOptions.RightAlign);
			}
		}
		#endregion Methods-Call-OpenClient

		#region Methods-RowSelection
		public void setCurrSelectedNum()
		{ 
			DataGridCell tableOneCell = new DataGridCell();
			tableOneCell.RowNumber = dataGridOne.CurrentRowIndex;
			tableOneCell.ColumnNumber = 0;
			iSelectNum = int.Parse(dataGridOne[tableOneCell].ToString());
			return; 
		}

		public void setCurrTableTwoNum()
		{ 
			DataGridCell tableTwoCell = new DataGridCell();
			tableTwoCell.RowNumber = dataGridTwo.CurrentRowIndex;
			tableTwoCell.ColumnNumber = 0;
			return; 
		}

		// Select the row (highlight) - unselect previous row
		public void selectGridOneRow(int selRowNum)
		{
			dataGridOne.Select(selRowNum); 
			dataGridOne.CurrentRowIndex = selRowNum;
			return; 
		}

		// Select the row (highlight) - unselect previous row
		public void selectGridTwoRow(int selRowNum)
		{
			try
			{
				try
				{
					// Unselect last selected row
					dataGridTwo.Select(selRowNum); 
				}
				catch (System.Exception ex)
				{
					dspMsg ="The following exception occured: \n\r" + ex.Message;
					dspCaption = "Selection Failed";
					dspButton = MessageBoxButtons.OK;
					resultDlog = MessageBox.Show(this, dspMsg, dspCaption, dspButton,
						MessageBoxIcon.Error,
						MessageBoxDefaultButton.Button1,
						MessageBoxOptions.RightAlign);
				}

				// Position view port for new row
				dataGridTwo.CurrentRowIndex = selRowNum;
				// Remember this row for unselect
				setCurrTableTwoNum(); 
			}
			catch (System.Exception ex)
			{
				dspMsg ="The following exception occured: \n\r" + ex.Message;
				dspCaption = "Selection Failed";
				dspButton = MessageBoxButtons.OK;
				resultDlog = MessageBox.Show(this, dspMsg, dspCaption, dspButton,
					MessageBoxIcon.Error,
					MessageBoxDefaultButton.Button1,
					MessageBoxOptions.RightAlign);
			}
			return; 
		}
		#endregion Methods-RowSelection

		#region Methods-Connection
		public void disconnectOpenClient()
		{
			if (appObj != null)
			{
				try
				{
					// Call .NET Open Client proxy to disconnect from the AppServer 
					appObj.Dispose();
					appObj = null; 
					statusBarPanelConnect.Text = "Not Connected ";
					statusBarPanelStatus.Icon = Utility.stopngo.Stop();
				}				
				catch (Progress.Open4GL.Exceptions.Open4GLException ex)
				{
					dspMsg = ex.Message;
					dspCaption = "Open 4GL Exception";
					dspButton = MessageBoxButtons.OK;
					resultDlog = MessageBox.Show(this, dspMsg, dspCaption, dspButton,
						MessageBoxIcon.Information,
						MessageBoxDefaultButton.Button1,
						MessageBoxOptions.RightAlign);
				}
				catch (System.Exception ex)
				{
					dspMsg = "Error: Couldn't release connection." + ex;
					dspCaption = "Error on release of connection";
					dspButton = MessageBoxButtons.OK;
					resultDlog = MessageBox.Show(this, dspMsg, dspCaption, dspButton,
						MessageBoxIcon.Error,
						MessageBoxDefaultButton.Button1,
						MessageBoxOptions.RightAlign);
				}
			}
			// Enable connect button to allow reconnect, if window is not closing
			buttonConnect.Enabled = true; 
			buttonDisconnect.Enabled = false; 
			buttonCallOC.Enabled = false; 
			modeNoOrderRecord(); 
			return;
		}
		#endregion Methods-Connection

		#region Methods-Modification
		// Examples here for add and delete.  An example of update is not implemented. 
		private void addRecord(DataRow newRow)
		{
			int nextLineNum = 0;
			int iOrderNum;  
			DataRow orderLineRow = null; 
			int dataGridRow = 0; 

			iOrderNum = currentOrder();

			// Find the last row based on linenum by sorting in line number descending order 
			//   If not available then this is the first orderline for the order
			DataRow[] selOlineRows = dtTableTwo.Select("OrderNum = " + iOrderNum, "LineNum DESC");
			if (selOlineRows.Length > 0)
			{			
				orderLineRow = selOlineRows[0];
				nextLineNum = int.Parse(orderLineRow["LineNum"].ToString());
			}
			// Add one for the new line number
			nextLineNum = nextLineNum + 1;

			// Add a row - NewRow is being done prior to calling procedure
			newRow[0] = iOrderNum;  // ordernum   
			newRow[1] = nextLineNum; // linenum

			// Populate new record with the values from last orderline row for this example
			if ((nextLineNum > 0) && (selOlineRows.Length > 0))
			{
				orderLineRow = selOlineRows[0]; 

				newRow[2] = orderLineRow[2]; // itemnum
				newRow[3] = orderLineRow[3]; // price
				newRow[4] = orderLineRow[4]; // qty
				newRow[5] = orderLineRow[5]; // discount
				newRow[6] = orderLineRow[6]; // extended price
				newRow[7] = "Ordered"; 
				dsOrders.Tables[1].Rows.Add(newRow);
				modeChangesPending(); 
			}
			else 
			{
				// If this is the first row then ...
				//  allways order qty 6 of item 33 - its a just an example :)
				newRow[2] = 33;		// itemnum
				newRow[3] = 13.96;	// price
				newRow[4] = 6;		// qty
				newRow[5] = 0;		// discount
				newRow[6] = 83.94;	// extended price
				newRow[7] = "Ordered"; 
				dsOrders.Tables[1].Rows.Add(newRow);
				modeChangesPending(); 
			}

			dataGridRow = vueTableTwo.Find(nextLineNum);
			if (dataGridRow == -1) 
			{
				// Error on add of new row since it was not found, ignored for this example
				dataGridRow = 0; 
			}
			selectGridTwoRow(dataGridRow);
		}

		private void deleteRecord()
		{
			int rowCnt;
			int iOrderNum; 

			iOrderNum = currentOrder();

			if (buttonDelete.Enabled == true)
			{
				DataRow[] selOlineRows = dtTableTwo.Select("OrderNum = " + iOrderNum);

				DataRow selectedRow = null; 
				rowCnt = 0;
				foreach (DataRow dRow in selOlineRows)
				{
					if (rowCnt == dataGridTwo.CurrentCell.RowNumber)
					{
						selectedRow = dRow; 
						break; 
					}
					rowCnt++; 
				}

				if (selectedRow != null)
				{
					dspMsg = "Are you sure you want to delete line " + selectedRow[1].ToString() + "?";
					dspCaption = "Delete Order Line";
					dspButton = MessageBoxButtons.YesNo;
					resultDlog = MessageBox.Show(this, dspMsg, dspCaption, dspButton,
						MessageBoxIcon.Question,
						MessageBoxDefaultButton.Button1,
						MessageBoxOptions.RightAlign);

					if(resultDlog == DialogResult.Yes)
					{
						selectedRow.Delete();
						selectGridTwoRow(dataGridTwo.CurrentCell.RowNumber);
						modeChangesPending(); 
					}
				}
			}
		}

		// Call AppObject to make updates to dataset for specified order number
		private void saveChanges()
		{
			nsUpdateExchg.StrongTypesNS.dsOrderDataSet dsUpdatedRecs;

			// Populate the dsUpdatedRecs DataSet with only the changed rows
			dsUpdatedRecs =  (nsUpdateExchg.StrongTypesNS.dsOrderDataSet)
				(dsOrders.GetChanges());

			// Confirm that there are updates before continuing
			if (dsUpdatedRecs != null)
			{
				try
				{
					// Pass the DataSet with the changed rows as an INPUT/OUTPUT parameter
					//  to the AppServer
					try
					{
						appObj.UpdateDS(bIgnoreChgs, bMergeField, ref dsUpdatedRecs);
					}		
					catch (Progress.Open4GL.Exceptions.Open4GLException ex)
					{
						dspMsg = ex.Message;
						dspCaption = "Open 4GL Exception";
						dspButton = MessageBoxButtons.OK;
						resultDlog = MessageBox.Show(this, dspMsg, dspCaption, dspButton,
							MessageBoxIcon.Information,
							MessageBoxDefaultButton.Button1,
							MessageBoxOptions.RightAlign);
					}

					if (dsUpdatedRecs.Tables[1].HasErrors)
					{
						dspMsg = "The following OrderLine row(s) were not updated successfully:";
						foreach(DataRow failedRow in dsUpdatedRecs.Tables[1].Rows)
						{
							if (failedRow.HasErrors)
							{
								dspMsg += "\n\r Line number: " + failedRow["linenum"].ToString() + 
									", Error Message: " + failedRow.RowError;
							}
						}
						dspCaption = "Rows not updated";
						dspButton = MessageBoxButtons.OK;
						resultDlog = MessageBox.Show(this, dspMsg, dspCaption, dspButton,
							MessageBoxIcon.Error,
							MessageBoxDefaultButton.Button1,
							MessageBoxOptions.RightAlign);
					}
					else
					{
						dspMsg ="All updates succeeded";
						dspCaption = "Save completed";
						dspButton = MessageBoxButtons.OK;
						resultDlog = MessageBox.Show(this, dspMsg, dspCaption, dspButton,
							MessageBoxIcon.Information,
							MessageBoxDefaultButton.Button1,
							MessageBoxOptions.RightAlign);
					}

					// Remove the pending new added order lines before merging 
					//	  This will prevent duplicate rows if the key fields on the 
					//    row number were changed during the update.  
					foreach(DataRow curRow in dtTableTwo.Select("", "", DataViewRowState.Added))
					{
						dtTableTwo.Rows.Remove(curRow); 
					}
					dsOrders.Merge(dsUpdatedRecs);
					//  Reset the row state for the modified rows now that changes have been merged
					dsOrders.AcceptChanges();
				}
				catch (Exception ex)
				{
					dspMsg ="The following exception occured: \n\r" + ex.Message;
					dspCaption = "Save Failed";
					dspButton = MessageBoxButtons.OK;
					resultDlog = MessageBox.Show(this, dspMsg, dspCaption, dspButton,
						MessageBoxIcon.Error,
						MessageBoxDefaultButton.Button1,
						MessageBoxOptions.RightAlign);
				}
			}

			modeViewing();
		}

		private void cancelChanges()
		{
			dspMsg = "Are you sure you want to reject all changes since your last save?";
			dspCaption = "Cancel Changes";
			dspButton = MessageBoxButtons.YesNo;
			resultDlog = MessageBox.Show(this, dspMsg, dspCaption, dspButton,
				MessageBoxIcon.Question,
				MessageBoxDefaultButton.Button1,
				MessageBoxOptions.RightAlign);

			// Restore deleted records, return modified to original, remove added records
			//   Update all flags.
			if(resultDlog == DialogResult.Yes)
			{
				dataGridTwo.UnSelect(dataGridTwo.CurrentCell.RowNumber);
				// A call to method RejectChanges on the DataSet will 
				//   reject all pending changes and restore to the state 
				//   since the last save, or the initial fill of the DataSet
				dsOrders.RejectChanges();

				// An alternative to RejectChanges is to Call appObj.OrderMain to return
				//    the current dataset for specified order number.
				//	  All pending changes will be lost.
				// getRecords();

				selectGridTwoRow(0); 
				modeViewing();  
			}
		}
		#endregion Methods-Modification

		#region Methods-ExtPrice
		// Calculate the Extended price based on price, qty, and discount
		private void calcOlineExtPrice(int currRowNumber)
		{
			decimal currPrice;
			int currQty;
			decimal currDiscount;  // must be decimal for calcualtion
			decimal currExtPrice = 0; 

			currPrice = decimal.Parse(dsOrders.Tables[1].Rows[currRowNumber][3].ToString()); 
			currQty = int.Parse(dsOrders.Tables[1].Rows[currRowNumber][4].ToString()); 
			currDiscount = decimal.Parse(dsOrders.Tables[1].Rows[currRowNumber][5].ToString()); 
			
			currExtPrice = currPrice * currQty;
			if (currDiscount != 0)
				currExtPrice = currExtPrice - (currExtPrice * (currDiscount / 100));
			dsOrders.Tables[1].Rows[currRowNumber][6] = currExtPrice.ToString(); 
			return;
		}

		// If leaving columns Qty or Discount then make updates as needed
		//    if columns changed
		private void updateExtPrice() 
		{
			DataGridCell olineCell = new DataGridCell();

			if (enteredQtyColumn == true)
			{
				// Check to see if the Qty was changed
				olineCell.RowNumber = enteredRowSave;
				olineCell.ColumnNumber = 4;
				int newQty = int.Parse(dataGridTwo[olineCell].ToString());
				if (originalQty != newQty)
				{
					calcOlineExtPrice(olineCell.RowNumber); 
					modeChangesPending();
				}

				// Processing of Qty complete - Clear fields
				enteredQtyColumn = false; 
				enteredRowSave = -1;
				originalQty = -1;
			}
			else if (enteredDiscountColumn == true)
			{
				// Check to see if the Discount was changed
				olineCell.RowNumber = enteredRowSave;
				olineCell.ColumnNumber = 5;
				if (originalDiscount != int.Parse(dataGridTwo[olineCell].ToString()))
				{
					calcOlineExtPrice(olineCell.RowNumber);
					modeChangesPending(); 
				}

				// Processing of Qty complete - Clear fields
				enteredDiscountColumn = false; 
				enteredRowSave = -1;
				originalDiscount = -1;
			}
			return;
		}
		#endregion Methods-ExtPrice

		#region Methods-Utility	
		// Set the UI for case where changes have been made to Order Line records
		private void modeChangesPending()
		{
			buttonSave.Enabled = true; 
			buttonCancel.Enabled = true;
			// Don't allow disconnect or update of displayed records if changes are pending
			buttonDisconnect.Enabled = false; 
			buttonCallOC.Enabled = false; 
			return;
		}

		// Set the UI for case where no changes are pending
		private void modeViewing()
		{
			buttonSave.Enabled = false; 
			buttonCancel.Enabled = false;
			if (buttonConnect.Enabled == false) 
			{
				buttonDisconnect.Enabled = true; 
			}
			buttonCallOC.Enabled = true; 
			return;
		}

		// Set the UI for case where Order record is available
		private void modeAvailOrderRecord()
		{
			buttonAdd.Enabled = true;
			buttonDelete.Enabled = true;
			return;
		}

		// Set the UI for case where Order record is NOT available
		private void modeNoOrderRecord()
		{
			buttonAdd.Enabled = false;
			buttonDelete.Enabled = false;
			return;
		}
		
		// Return the order number for the currently selected order
		private int currentOrder()
		{
			DataGridCell gridOneCell = new DataGridCell();

			// Get the selected order number 
			gridOneCell.RowNumber = dataGridOne.CurrentCell.RowNumber;
			// Column 0 is the location of the OrderNum field in dataGridOne
			gridOneCell.ColumnNumber = 0;
			return int.Parse(dataGridOne[gridOneCell].ToString());
		}

		private void initializeGrids()
		{
			DataGridTextBoxColumn wrkGridTextBoxColumn1;
			DataGridTableStyle olineTableStyle = new DataGridTableStyle(); 
			string tableName; 

			dataGridOne.ReadOnly = true;
			tableName = dsOrders.Tables[1].TableName;

			// Set up table style for Order Line DataGrid
			olineTableStyle.MappingName = tableName;
			dataGridTwo.TableStyles.Add(olineTableStyle);
			dataGridTwo.TableStyles[tableName].GridColumnStyles[0].ReadOnly = true;
			dataGridTwo.TableStyles[tableName].GridColumnStyles[1].ReadOnly = true;
			dataGridTwo.TableStyles[tableName].GridColumnStyles[2].ReadOnly = true;
			dataGridTwo.TableStyles[tableName].GridColumnStyles[3].ReadOnly = true;
			dataGridTwo.TableStyles[tableName].GridColumnStyles[6].ReadOnly = true;
			dataGridTwo.TableStyles[tableName].GridColumnStyles[7].ReadOnly = true;
				
			wrkGridTextBoxColumn1 = (DataGridTextBoxColumn) dataGridTwo.TableStyles[tableName].GridColumnStyles["Price"];
			wrkGridTextBoxColumn1.Format = "f";
			wrkGridTextBoxColumn1 = (DataGridTextBoxColumn) dataGridTwo.TableStyles[tableName].GridColumnStyles["ExtendedPrice"];
			wrkGridTextBoxColumn1.Format = "f";
			return; 
		}
		#endregion Methods-Utility
	}
}
